# Dans cette séance de TP on va utiliser le logiciel Python Tutor pour
# exécuter pas à pas notre code en visualisant quelle ligne est
# exécutée à chaque moment et quelles sont les valeurs courantes des
# variables. Cela vous permet de trouver des erreurs dans le code,
# ainsi que de vérifier si vos réponses aux exercices du type 
# « Exécutez le code en montrant les étapes de calcul » sont exactes.

# Pour utiliser Python Tutor, ouvrez la page web suivante :
#
#     https://pythontutor.com/python-compiler.html
#
# écrivez (ou collez) le code dans la fenêtre « Write code in Python
# 3.6 » en bas de la page, changez l'option « hide exited frames
# [default] » à « show all frames (Python) » et cliquez « Visualize
# Execution ».

# Maintenant vous pouvez exécuter une étape de calcul en cliquant sur
# « Next ». Python Tutor vous montrera la ligne courante (flèche
# rouge), la ligne précédemment exécutée (flèche verte claire) et, sur
# la droite, les valeurs courantes des variables le long de
# l'exécution du code. Vous pouvez même revenir en arrière en
# utilisant le bouton « Prev ».

# Si vous avez besoin de modifier le code, ou recommencer avec du
# nouveau code pour l'exercice suivant, cliquez sur « Edit this code ».

# Quand vous révisez, n'hésitez pas à utiliser Python Tutor chaque
# fois que vous avez un doute sur l'exécution d'un morceau de code
# Python.





# Exercice 1. Exécution du code

# Considérez l'algorithme suivant, qui prend en entrée deux entiers
# naturels (entiers positifs ou nuls), 
# et qui le teste sur l'entrée 2, 3 :

def mystery(x, y):
    r = 0
    while x > 0:
        r = r + 1
        x = x - 1
    while y > 0:
        r = r + 1
        y = y - 1
    return r


print('mystery(2, 3) vaut', mystery(2, 3))


# Montrez l'exécution du calcul mystery(2, 3) sur papier, en
# remplissant une table avec une colonne pour le numéro de ligne et
# une colonne pour chaque variable, comme on a vu en cours.

# Après, collez le code ci-dessus (y compris le test) dans Python
# Tutor et exécutez-le ligne par ligne, en vérifiant à chaque étape
# que la ligne correspondante de la table soit correcte. (Remarquez
# que Python Tutor ne montre que la valeur courante des variables,
# alors que nos tables contiennent toute l'histoire des valeurs.)

# Changez l'appel mystery(2, 3) en choisissant d'autres entiers
# naturels comme entrée et exécutez le code ligne par ligne
# jusqu'à comprendre ce que cet algorithme renvoie.





# Exercice 2. Appels de fonction

# Exécutez dans Python Tutor le code suivant ligne par ligne, pour
# apprendre comment Python Tutor montre les appels de fonction. Pour
# cet exercice, assurez-vous d'avoir changé l'option « hide exited
# frames [default] » à « show all frames (Python) ».


def double(n):
    return 2 * n


def plus_three(n):
    return n + 3


def four_times_plus_three(n):
    return plus_three(double(double(n)))


print('four_times_plus_three(4) vaut', four_times_plus_three(4))





# Exercice 3. Compléter le code

# On veut écrire un algorithme qui renvoie le carré de son entrée n.
# Initialement, il y a un trou dans le code (le « ... »). Collez le
# code dans Python Tutor pour exécuter le test sur square(3),
# exécutez-le pas à pas et comptez combien de fois on exécute la ligne
# « ... ». Essayez aussi avec d'autres valeurs en entrée.

# Compte tenu du résultat attendu, déduisez le code à écrire à la
# place de « ... » (sans modifier le reste de l'algorithme),
# écrivez-le et testez-le en essayant plusieurs valeurs en entrée.


def square(n):
    r = 0
    for i in range(n):
        for j in range(n):
            ...
    return r


print('square(3) vaut', square(3))





# Exercice 4. Exécution de code

# Exécutez avec Python Tutor le code suivant, qu'on a vu en cours,
# pour vérifier si c'est correct et, sinon, pour trouver l'erreur et
# le corriger.


def somme(n):
    s = 0
    i = 1
    while i <= n:
        s = s + i
    return s


print('somme(4) vaut', somme(4))





# Exercice 5. Débogage

# L'algorithme suivant est sensé calculer x**y (x puissance y), mais
# il y a 2 (deux) erreurs dans le code, donc le résultat n'est pas
# correct. Exécutez pas à pas le test power(2, 5), ainsi que d'autres
# tests si nécessaire, pour trouver et corriger les erreurs.


def power(x, y):
    r = 0
    i = 0
    while i < y:
        r = r * x
    return r


print('power(2, 5) vaut', power(2, 5))





# Exercice 6. Débogage

# L'algorithme suivant est censé calculer la factorielle de n,
# c'est-à-dire le produit des entiers naturels de 1 à n compris, mais
# il y a 5 (cinq) erreurs dans le code. Exécutez pas à pas le test
# sur factorial(5) avec Python Tutor, ainsi que d'autres appels si
# nécessaire, pour trouver et corriger les erreurs.


def factorial(n):
    result = 0
    i = 0
    while i < n:
        result = result * i
    return i


print('factorial(5) vaut', factorial(5))





# Exercice 7. Débogage

# L'algorithme suivant est sensé calculer la racine carrée entière de
# n, c'est-à-dire la partie entière de la racine carrée de n 
# (on arrondit en bas). En effet, isqrt(0) renvoie 0, isqrt(1) renvoie 1, 
# isqrt(4) renvoie 2, etc. 
# Cependant, l'algorithme ne marche pas correctement si
# n n'est pas un carré parfait : par exemple, isqrt(24) renvoie 5,
# alors que le bon résultat est 4. Corrigez le code en utilisant
# Python Tutor.


def isqrt(n):
    r = 0
    while r * r < n:
        r = r + 1
    return r


print('isqrt(3) vaut', isqrt(3))





# Exercice 8. Interprétation du code

# Qu'est-ce que l'algorithme suivant calcule ? Exécutez avec Python
# Tutor plusieurs tests pour essayer d'en comprendre la logique.


def puzzle(n):
    x = 0
    for i in range(n + 1):
        if i % 2 == 0:
            x = x + i
    return x


print('puzzle(5) vaut', puzzle(5))





# Exercice 9. Interprétation du code

# L'algorithme suivant utilise une boucle for sur l'intervalle
# range(2, n) : il s'agit de l'intervalle qui va de 2 compris à n non
# compris (alors que l'intervalle range(n) va de 0 compris à n non compris).

# Exécutez les deux calculs enigma(9) et enigma(5), d'abord à la
# main sur papier, puis avec Python Tutor, en faisant d'autres tests
# si nécessaire, jusqu'à comprendre ce que l'algorithme renvoie.


def enigma(n):
    if n <= 1:
        return False
    for d in range(2, n):
        if n % d == 0:
            return False
    return True


print('enigma(9) vaut', enigma(9))
